AutoCAD Land Desktop (Read Only)
cancel
Showing results for 
Show  only  | Search instead for 
Did you mean: 

Get Current Surface from Surface Object

1 REPLY 1
Reply
Message 1 of 2
Tallboy44
1435 Views, 1 Reply

Get Current Surface from Surface Object

I am writing a LISP routine (I know I need to switch to VBA but I am in a hurry on this one) to obtain the surface elevation for each AEC Point of a set of points. My project has several surfaces that have created over the span of a couple of months and I want the routine to use the current surface selected in Terrain Model Explorer (TME) to pass the current surface object information to the following code excerpt:

 

(vlax-invoke-method cur_surf "getelevation" e n)

 

Examples of code I've seen elsewhere in the discussion group provide specific counters in the surface object as listed below, but this specific example does not "grab" the current surface (It appears the counter "0" below grabs the first surface created chronologically, a counter of "1" grabs the second surface created chronologically, and so on):

 

(setq cur_surf (vla-item surfs 0))

 

Thanks in advance for help on this.

1 REPLY 1
Message 2 of 2
Jeff_M
in reply to: Tallboy44

This should help:

(vl-load-com)  
(setq vrsn (vlax-product-key))
  (cond	((vl-string-search "R16.2" vrsn) (setq appstr "4"))
	;;2006
	((vl-string-search "R17.0" vrsn) (setq appstr "6"))
	;;2007
	((vl-string-search "R17.1" vrsn) (setq appstr "7"))
	;;2008
	((vl-string-search "R17.2" vrsn) (setq appstr "8"))
	;;2009
	(t (alert "This version of LDT not supported!"))
  )

  (and (setq acadObj (vlax-get-acad-object))
       (setq aeccApp (vla-getInterfaceObject
		       acadObj
		       (strcat "Aecc.Application." appstr)
		     )
       )
       (setq aeccDoc (vla-get-activedocument aeccApp))
       (setq aeccUtil (vlax-get aeccDoc "utility"))
       (setq aeccProj (vlax-get aeccApp 'activeProject))
       (setq aeccAligns (vlax-get aeccProj 'alignments))
       (setq CurAlignName (vlax-get aeccAligns 'currentalignment))
       (setq aeccAlign (vlax-invoke aeccAligns 'item curalignname))

       (setq aecSurfs (vlax-get aeccProj "Surfaces"))
       (setq aecSurf (vlax-get aecSurfs "Currentsurface"))
       (setq aecSurf (vla-item aecSurfs aecSurf))
  )

 

Jeff_M, also a frequent Swamper
EESignature

Can't find what you're looking for? Ask the community or share your knowledge.

Post to forums  

Autodesk Design & Make Report